#include <math.h>
#include <stdlib.h>
#include <stdio.h>

/* Mathematical algorithm taken from
 * http://home.online.no/~pjacklam/notes/invnorm/
 */
double quantile(double p)
{
	double q,r,a0[6],b0[5],c0[6],d0[4];
	double *a, *b, *c, *d;
	double p_low, p_high, x=0;

	a=a0;
	b=b0;
	c=c0;
	d=d0;
	a--;
	b--;
	c--;
	d--;

    a[1] = -3.969683028665376e+01;
    a[2] =  2.209460984245205e+02;
    a[3] = -2.759285104469687e+02;
    a[4] =  1.383577518672690e+02;
    a[5] = -3.066479806614716e+01;
    a[6] =  2.506628277459239e+00;

    b[1] = -5.447609879822406e+01;
    b[2] =  1.615858368580409e+02;
    b[3] = -1.556989798598866e+02;
    b[4] =  6.680131188771972e+01;
    b[5] = -1.328068155288572e+01;
                                  
    c[1] = -7.784894002430293e-03;
    c[2] = -3.223964580411365e-01;
    c[3] = -2.400758277161838e+00;
    c[4] = -2.549732539343734e+00;
    c[5] =  4.374664141464968e+00;
    c[6] =  2.938163982698783e+00;
                                  
    d[1] =  7.784695709041462e-03;
    d[2] =  3.224671290700398e-01;
    d[3] =  2.445134137142996e+00;
    d[4] =  3.754408661907416e+00;

   /* Define break-points. */                                                       
                                                                                
    p_low  = 0.02425;
    p_high = 1 - p_low;                                                         
                                                                                
    /* Rational approximation for lower region. */
                                                                                
    if (p < p_low){                                                            
       q = sqrt(-2*log(p));                                                     
       x = (((((c[1]*q+c[2])*q+c[3])*q+c[4])*q+c[5])*q+c[6]) /                 
             ((((d[1]*q+d[2])*q+d[3])*q+d[4])*q+1);
    }    
    if ((p_low <= p) && (p <= p_high)){                                                     
       q = p - 0.5;                                                             
       r = q*q;                                                                 
       x = (((((a[1]*r+a[2])*r+a[3])*r+a[4])*r+a[5])*r+a[6])*q /               
            (((((b[1]*r+b[2])*r+b[3])*r+b[4])*r+b[5])*r+1);
    }    
    if (p_high < p){                                                           
       q = sqrt(-2*log(1-p));
       x = -(((((c[1]*q+c[2])*q+c[3])*q+c[4])*q+c[5])*q+c[6]) /                
              ((((d[1]*q+d[2])*q+d[3])*q+d[4])*q+1);
    }
    return x;
}

void snrstats(int sent, int received, int payload_bytes)
{
	double bgr,snr; /* bgr = bit good rate = 1-BER */
	int nbits;

	nbits=payload_bytes*8+400;
	bgr=pow((double)received/(double)sent,1.0/(double)nbits);
	printf("Bit Error Rate: %lf\n",1-bgr);
	printf("Ratio of signal photon rate to equivalent noise photon AC rate is"
		" %lf:1\n",snr=quantile(bgr));
	printf("SNR=%.2lf dB\n",10*log10(snr));
}


